import processing.net.*;
import procontroll.*;
import java.io.*;

ControllIO controll;
Joystick joystick;
Joystick[] joysticks = new Joystick[2];

int port = 5204;
boolean myServerRunning = true;
int textLine = 60;
String msg;
String[] directions = new String[2];
float x,y;

Server myServer;

void setup() {
  size(120, 120);

  controll = ControllIO.getInstance(this);
  int num=controll.getNumberOfDevices();
  for (int z=2; z<num; z++) {
    joysticks[z-2] = new Joystick(controll.getDevice(z), z-2);
  }
  myServer = new Server(this, port);
  background(0);
}

public void stop() {
  myServer.stop();
  myServerRunning = false;
}

void draw() {
  if (myServerRunning == true)
  {
    String s_msg="<?xml version='1.0' ?><ctrl>";
    boolean sendit=false;
    for (int z=0; z<joysticks.length; z++) {
     if (joysticks[z].needUpdate()) {
      s_msg += joysticks[z].getCompleteXML();
      sendit=true;
     }
    }
    if (sendit) {
      s_msg += "</ctrl>\0";
      myServer.write(s_msg);
      fill(random(10)*20);
      rect(50,50,20,20);
    }
  } 
}


